'''
Created on 1 May 2013

@author: maxz
'''
from threading import Thread
from multiprocessing import Value


class _Async_Optimization(Thread):

    def __init__(self, f, df, x0, update_rule, runsignal,
                 report_every=10, messages=0, maxiter=5e3, max_f_eval=15e3,
                 gtol=1e-6, outqueue=None, *args, **kw):
        """
        Helper Process class for async optimization
        
        f_call and df_call are Multiprocessing Values, for synchronized assignment
        """
        self.f_call = Value('i', 0)
        self.df_call = Value('i', 0)
        self.f = self.f_wrapper(f)
        self.df = self.df_wrapper(df)
        self.x0 = x0
        self.iter = 0
        self.update_rule = update_rule
        self.report_every = report_every
        self.messages = messages
        self.maxiter = maxiter
        self.max_f_eval = max_f_eval
        self.gtol = gtol
        self.runsignal = runsignal
#         self.parent = parent
#         self.result = None
        self.outq = outqueue
        super(_Async_Optimization, self).__init__(target=self.run,
                                            name="CG Optimization",
                                            *args, **kw)

#     def __enter__(self):
#         return self
#
#     def __exit__(self, type, value, traceback):
#         return isinstance(value, TypeError)

    def f_wrapper(self, f):
        def f_w(*a, **kw):
            self.f_call.value += 1
            self.fi = f(*a, **kw)
            return 
        return f_w

    def df_wrapper(self, f):
        def f_w(*a, **kw):
            self._df_call.value += 1
            return f(*a, **kw)
        return f_w

    def callback(self, *a):
        self.outq.put(a)
#         self.parent and self.parent.callback(*a, **kw)
        pass
        # print "callback done"

    def callback_return(self, *a):
        self.callback(*a)
        self.outq.put(SENTINEL)
        self.runsignal.clear()

    def run(self, *args, **kwargs):
        raise NotImplementedError("Overwrite this with optimization (for async use)")
        pass


class AsyncOptimization(object):
    
    def __init__(self, fmin):
        self.opt_fmin = fmin
        
    def fmin(self, f, df, x0, *a, **kw):
        
        
        